#!/usr/bin/env python3
"""
Mail Blacklist
by Javantea
May 22, 2015

A blacklist system for AltSci Maildir.

Based on Mail1 CLI.
"""
from __future__ import print_function
import mail1
import os
import sys
import codecs
import urllib.parse
import collections

blacklist = collections.defaultdict(int)

dirName = '/home/jvoss/Mail/.inbox.directory/spam1/cur'
a = mail1.readDir(dirName)
filtera = a['files']
filtera.sort(reverse = True)
for message in filtera:
    fname = dirName + os.sep + message
    f = open(fname, 'rb').read()
    msg = mail1.message_from_bytes(f)
    mfrom = str(msg['from']).replace('\n','')
    blacklist[mfrom] += 1
#next message

# sort -nr blacklist1a.txt |head -n 100 
# gives you the top 100 offenders and how many e-mails they have sent you.
# This is very useful in finding false positives and blacklist potential.
# Remember to remove the integer and the space at the front.
open('blacklist1b.txt','w').write('\n'.join(['%i %s' % (v[1],v[0]) for v in dict(blacklist).items()]))

