#!/usr/bin/env python3
"""
Validation of Average Slowdown Claim for mitigation of DoS against Python3.3 
email.message_from_binary_file
by Javantea
Sept 24, 2015

The test is running email.message_from_binary_file on 3852 legitimate non-spam 
e-mail files.

# Without feedparser_dos.patch applied (with caching):
time python3 mail1_all.py ~/Mail/badkm/cur/143*

real    0m5.875s
user    0m5.827s
sys     0m0.047s

# With feedparser_dos.patch applied (with caching):
time python3 mail1_all.py ~/Mail/badkm/cur/143*

real    0m5.929s
user    0m5.881s
sys     0m0.047s

Slowdown = (5.881-5.827)/3852 = 0.054s/3852mails = 1.40e-5 s/mail
<1.4e-5 slowdown in the average case.
The error bar for this measurement is large compared to the value. Allow me to 
demonstrate.

user    0m5.978s
user    0m6.006s
user    0m5.953s
user    0m5.930s

Since it's slow, I will create the error bar for just these three.

import numpy as np
a = [5.978,6.006,5.953,5.930]
avg = np.average(a)
# 5.96675
std = np.std(a)
# 0.02831

The std dev for this value is 0.02831, while the difference between the two 
values is 0.054. This gives us a fairly low confidence value for this. However, 
the worst case scenario is simply:
max(patched times) - min(unpatched times) / 3852
6.006 - 5.871 = 0.135/3852 = 3.5e-5 seconds per message
Thus our worst case scenario for slowdown in the average case is 3.5e-5 seconds 
per message. Well within acceptable limits.
"""
from __future__ import print_function
import email
import os
import sys

for filename in sys.argv[1:]:
	fp = open(filename,'rb')
	m = email.message_from_binary_file(fp)
#next filename

