#!/usr/bin/env python3
"""
Mail to Bin
by Javantea
Sept 23, 2015

Convert an e-mail file to a bunch of files.

"""
from __future__ import print_function
import email
import os

def dump_message(filename):
	"""
	TODO: Create a function that returns a list of binaries instead.
	"""
	# Use message_from_binary_file
	# FIXME: python2 support
	msg = email.message_from_binary_file(open(filename,'rb'))
	i = 1
	for part in msg.walk():
		content_type = part.get_content_type()
		print(content_type)
		sub_filename = part.get_filename()
		print(sub_filename)
		write_to_file = False
		if content_type == 'multipart/mixed':
			pass
		elif content_type == 'multipart/alternative':
			pass
		elif content_type == 'application/pgp-encrypted':
			write_to_file = True
		elif content_type == 'text/plain':
			write_to_file = True
		elif content_type == 'application/octet-stream':
			write_to_file = True
		else:
			print("Warning: I do not know what file type we're dealing with.")
			write_to_file = True
		#end if
		if write_to_file:
			if sub_filename:
				if '../' in sub_filename:
					print("Error: path traversal {0}".format(sub_filename))
					continue
				#end if
				sfna = '.' + sub_filename
			else:
				sfna = ('.%03i' % i)
			#end if
			if os.path.exists(filename + sfna):
				print("Error: Unwilling to overwrite %s." % (filename + sfna))
				i += 1
				continue
			#end if
			data = part.get_payload(decode=True)
			if data == None: continue
			open(filename + sfna, 'wb').write(data)
			i += 1
		#end if
	#next part
	return True
#end def dump_message(filename)

def main():
	import sys
	filename = os.path.expanduser('~/Downloads/encrypted')
	if len(sys.argv) > 1:
		filename = sys.argv[1]
	#end if
	dump_message(filename)
#end def main()

if __name__ == '__main__':
	main()
#end if
